﻿<AML>
 <Item type="Method" id="9290FC65C11140D384896690DB96C0E9" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_ProfitandLoss_Cash_sp
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                Getting Required Information for Report

            Hooks:
                
                Called by:	acc_balancesheet_sp_call
                            acc_ProfitandLoss_sp_call

            Inputs:
                acc_from_date,
                acc_to_date,
                acc_accounting_method,
                acc_report_currency

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_ProfitandLoss_Cash_sp";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var symbol = "";
                var acc_from_date = this.getProperty("acc_from_date", "");
                var acc_to_date = this.getProperty("acc_to_date", "");

                DateTime dt_acc_date = DateTime.Parse(acc_to_date);
                string acc_month = dt_acc_date.Month.ToString();
                string acc_year = dt_acc_date.Year.ToString();

                var acc_accounting_method = this.getProperty("acc_accounting_method", "");
                var acc_report_currency = this.getProperty("acc_report_currency", "");
                string query = "";
                var clear_report_data = myInnovator.applySQL("DELETE FROM innovator.acc_ProfitandLoss_report");

                string date_condition = "   AND (Convert(Date,ACC_JOURNAL_HEADER.acc_date,111) Between Convert(Date,'" + acc_from_date + "',111) "
                    + " and  Convert(Date,'" + acc_to_date + "',111))";

                if (acc_report_currency == "USD")
                {
                    symbol = "US$";
                    query = "select  acc_accounttype,acc_accountconsole,acc_accountdetail_code,acc_accountdetail_name,"
                 + " sum(acc_amount) acc_amount,"
                 + "sum(case when month(acc_date) ='" + acc_month + "' and year(acc_date) ='" + acc_year + "' then acc_amount else 0 end) acc_thismonth_amount "
                 + " from ( select ACC_JOURNAL_HEADER.acc_date,ACC_ACCOUNTTYPE,acc_accountconsole,acc_accountdetail_code,acc_accountdetail_name,ACC_CREDIT,"
                 + " ACC_DEBIT,  ACC_SOP_VOUCHER_REFERENCE, "
                 + " IIF(ACC_ACCOUNTTYPE='Income',ACC_CREDIT-ACC_DEBIT,ACC_DEBIT-ACC_CREDIT) as acc_amount "
                + " from innovator.ACC_JOURNAL_DETAILS "
                + " inner join innovator.ACC_JOURNAL_HEADER on ACC_JOURNAL_DETAILS.SOURCE_ID=ACC_JOURNAL_HEADER.id   "
                + " inner join innovator.ACC_ACCOUNTDETAILS on ACC_JOURNAL_DETAILS.ACC_ACCOUNTID=ACC_ACCOUNTDETAILS.id   "
                + " inner join innovator.ACC_CHARTOFACCOUNT on ACC_CHARTOFACCOUNT.id=ACC_ACCOUNTDETAILS.SOURCE_ID   "
                + " where (acc_accounttype='Income' or  acc_accounttype='COGS' or acc_accounttype='Expenses') "
                + " and acc_sop_voucher_reference is null  and acc_pop_voucher_reference is null   " + date_condition

                 + " Union ALL "
                 + " select ACC_JOURNAL_HEADER.acc_date,"

                 + " IIF(ACC_ACCOUNTTYPE='Assets','Income',ACC_ACCOUNTTYPE) as  ACC_ACCOUNTTYPE,"
                 + "IIF(ACC_ACCOUNTTYPE='Assets',(select acc_accountconsole from innovator.ACC_ACCOUNTDETAILS where id=sop_sale_invoice.acc_account),ACC_ACCOUNTCONSOLE) as  ACC_ACCOUNTCONSOLE,"
                + " IIF(ACC_ACCOUNTTYPE='Assets',(select acc_accountdetail_code from innovator.ACC_ACCOUNTDETAILS where id=sop_sale_invoice.acc_account),acc_accountdetail_code) as  acc_accountdetail_code,"
                 + "IIF(ACC_ACCOUNTTYPE='Assets',(select acc_accountdetail_name from innovator.ACC_ACCOUNTDETAILS where id=sop_sale_invoice.acc_account),acc_accountdetail_name) as  acc_accountdetail_name, "
                 + "ACC_CREDIT,ACC_DEBIT,ACC_SOP_VOUCHER_REFERENCE, "
                 + " IIF(ACC_ACCOUNTTYPE='Assets',(ACC_CREDIT-ACC_DEBIT)/(1+(pop_gst_percent/100)),IIF(ACC_ACCOUNTTYPE='Income',ACC_CREDIT-ACC_DEBIT,ACC_DEBIT-ACC_CREDIT)) as acc_amount   "
                + " from innovator.ACC_JOURNAL_DETAILS "
                + "inner join innovator.ACC_JOURNAL_HEADER on   ACC_JOURNAL_DETAILS.SOURCE_ID=ACC_JOURNAL_HEADER.id  "
                + "inner join innovator.ACC_ACCOUNTDETAILS on ACC_JOURNAL_DETAILS.ACC_ACCOUNTID=ACC_ACCOUNTDETAILS.id "
                + "inner join innovator.ACC_CHARTOFACCOUNT on ACC_CHARTOFACCOUNT.id=ACC_ACCOUNTDETAILS.SOURCE_ID "
                + "inner join innovator.sop_sale_invoice on ACC_JOURNAL_HEADER.ACC_SOP_VOUCHER_REFERENCE=sop_sale_invoice.id "
                + " inner join innovator.ACC_ACCOUNTSRECEIVABLE on ACC_JOURNAL_HEADER.ACC_REFNO=ACC_ACCOUNTSRECEIVABLE.ACC_REFERENCE_NO  "
                + " where ACC_ACCOUNTCONSOLE<>'Cash at Bank' and  ACC_ACCOUNTCONSOLE<>'Cash & cash equivalent'"
                + date_condition

                  + "   Union ALL "
                  + " select ACC_JOURNAL_HEADER.acc_date,"
                  + "IIF(ACC_ACCOUNTTYPE='Liabilities','COGS',ACC_ACCOUNTTYPE) as  ACC_ACCOUNTTYPE,"
                  + "IIF(ACC_ACCOUNTTYPE='Liabilities',(select acc_accountconsole from innovator.ACC_ACCOUNTDETAILS where id=POP_PURCHASE_INVOICE.acc_account),ACC_ACCOUNTCONSOLE) as  ACC_ACCOUNTCONSOLE,"
                  + " IIF(ACC_ACCOUNTTYPE='Liabilities',(select acc_accountdetail_code from innovator.ACC_ACCOUNTDETAILS where id=POP_PURCHASE_INVOICE.acc_account),acc_accountdetail_code) as  acc_accountdetail_code, "
                  + "IIF(ACC_ACCOUNTTYPE='Liabilities',(select acc_accountdetail_name from innovator.ACC_ACCOUNTDETAILS where id=POP_PURCHASE_INVOICE.acc_account),acc_accountdetail_name) as  acc_accountdetail_name,"
                  + "ACC_CREDIT,ACC_DEBIT, ACC_POP_VOUCHER_REFERENCE, "
                  + " IIF(ACC_ACCOUNTTYPE='Liabilities',(ACC_DEBIT-ACC_CREDIT)/(1+(pop_gst_percent/100)),IIF(ACC_ACCOUNTTYPE='Income',ACC_CREDIT-ACC_DEBIT,ACC_DEBIT-ACC_CREDIT)) as acc_amount "
                  + " from innovator.ACC_JOURNAL_DETAILS "
                 + " inner join innovator.ACC_JOURNAL_HEADER on  ACC_JOURNAL_DETAILS.SOURCE_ID=ACC_JOURNAL_HEADER.id  "
                 + " inner join innovator.ACC_ACCOUNTDETAILS on ACC_JOURNAL_DETAILS.ACC_ACCOUNTID=ACC_ACCOUNTDETAILS.id "
                 + " inner join innovator.ACC_CHARTOFACCOUNT on ACC_CHARTOFACCOUNT.id=ACC_ACCOUNTDETAILS.SOURCE_ID  "
                  + "inner join innovator.POP_PURCHASE_INVOICE on ACC_JOURNAL_HEADER.ACC_POP_VOUCHER_REFERENCE=POP_PURCHASE_INVOICE.id"
                 + " inner join innovator.ACC_ACCOUNTPAYABLE on ACC_JOURNAL_HEADER.ACC_REFNO=ACC_ACCOUNTPAYABLE.ACC_REFERENCENO "
                 + " where ACC_ACCOUNTCONSOLE<>'Cash at Bank' and  ACC_ACCOUNTCONSOLE<>'Cash & cash equivalent'"
                 + date_condition

                  + " )  as Temp_Profit_and_Loss group by acc_accountdetail_code,acc_accountdetail_name,acc_accountconsole,ACC_ACCOUNTTYPE ";
                }
                else
                {
                    symbol = "S$";
                    query = "select  acc_accounttype,acc_accountconsole,acc_accountdetail_code,acc_accountdetail_name,"
                 + " sum(acc_amount) acc_amount, "
                 + "sum(case when month(acc_date) ='" + acc_month + "' and year(acc_date) ='" + acc_year + "' then acc_amount else 0 end) acc_thismonth_amount "
                 + "from ( select ACC_JOURNAL_HEADER.acc_date,ACC_ACCOUNTTYPE,acc_accountconsole,acc_accountdetail_code,acc_accountdetail_name,acc_sg_credit,"
                 + " acc_sg_debit,  ACC_SOP_VOUCHER_REFERENCE, "
                 + " IIF(ACC_ACCOUNTTYPE='Income',acc_sg_credit-acc_sg_debit,acc_sg_debit-acc_sg_credit) as acc_amount "
                + " from innovator.ACC_JOURNAL_DETAILS "
                + " inner join innovator.ACC_JOURNAL_HEADER on ACC_JOURNAL_DETAILS.SOURCE_ID=ACC_JOURNAL_HEADER.id   "
                + " inner join innovator.ACC_ACCOUNTDETAILS on ACC_JOURNAL_DETAILS.ACC_ACCOUNTID=ACC_ACCOUNTDETAILS.id   "
                + " inner join innovator.ACC_CHARTOFACCOUNT on ACC_CHARTOFACCOUNT.id=ACC_ACCOUNTDETAILS.SOURCE_ID   "
                + " where (acc_accounttype='Income' or  acc_accounttype='COGS' or acc_accounttype='Expenses') "
                + " and acc_sop_voucher_reference is null  and acc_pop_voucher_reference is null   " + date_condition

                 + " Union ALL "
                 + " select ACC_JOURNAL_HEADER.acc_date,"

                 + " IIF(ACC_ACCOUNTTYPE='Assets','Income',ACC_ACCOUNTTYPE) as  ACC_ACCOUNTTYPE,"
                 + "IIF(ACC_ACCOUNTTYPE='Assets',(select acc_accountconsole from innovator.ACC_ACCOUNTDETAILS where id=sop_sale_invoice.acc_account),ACC_ACCOUNTCONSOLE) as  ACC_ACCOUNTCONSOLE,"
                + " IIF(ACC_ACCOUNTTYPE='Assets',(select acc_accountdetail_code from innovator.ACC_ACCOUNTDETAILS where id=sop_sale_invoice.acc_account),acc_accountdetail_code) as  acc_accountdetail_code,"
                 + "IIF(ACC_ACCOUNTTYPE='Assets',(select acc_accountdetail_name from innovator.ACC_ACCOUNTDETAILS where id=sop_sale_invoice.acc_account),acc_accountdetail_name) as  acc_accountdetail_name, "
                 + "acc_sg_credit,acc_sg_debit,ACC_SOP_VOUCHER_REFERENCE, "
                 + " IIF(ACC_ACCOUNTTYPE='Assets',(acc_sg_credit-acc_sg_debit)/(1+(pop_gst_percent/100)),IIF(ACC_ACCOUNTTYPE='Income',acc_sg_credit-acc_sg_debit,acc_sg_debit-acc_sg_credit)) as acc_amount   "
                + " from innovator.ACC_JOURNAL_DETAILS "
                + "inner join innovator.ACC_JOURNAL_HEADER on   ACC_JOURNAL_DETAILS.SOURCE_ID=ACC_JOURNAL_HEADER.id  "
                + "inner join innovator.ACC_ACCOUNTDETAILS on ACC_JOURNAL_DETAILS.ACC_ACCOUNTID=ACC_ACCOUNTDETAILS.id "
                + "inner join innovator.ACC_CHARTOFACCOUNT on ACC_CHARTOFACCOUNT.id=ACC_ACCOUNTDETAILS.SOURCE_ID "
                + "inner join innovator.sop_sale_invoice on ACC_JOURNAL_HEADER.ACC_SOP_VOUCHER_REFERENCE=sop_sale_invoice.id "
                + " inner join innovator.ACC_ACCOUNTSRECEIVABLE on ACC_JOURNAL_HEADER.ACC_REFNO=ACC_ACCOUNTSRECEIVABLE.ACC_REFERENCE_NO  "
                + " where ACC_ACCOUNTCONSOLE<>'Cash at Bank' and  ACC_ACCOUNTCONSOLE<>'Cash & cash equivalent'"
                + date_condition

                  + "   Union ALL "
                  + " select ACC_JOURNAL_HEADER.acc_date,"
                  + "IIF(ACC_ACCOUNTTYPE='Liabilities','COGS',ACC_ACCOUNTTYPE) as  ACC_ACCOUNTTYPE,"
                  + "IIF(ACC_ACCOUNTTYPE='Liabilities',(select acc_accountconsole from innovator.ACC_ACCOUNTDETAILS where id=POP_PURCHASE_INVOICE.acc_account),ACC_ACCOUNTCONSOLE) as  ACC_ACCOUNTCONSOLE,"
                  + " IIF(ACC_ACCOUNTTYPE='Liabilities',(select acc_accountdetail_code from innovator.ACC_ACCOUNTDETAILS where id=POP_PURCHASE_INVOICE.acc_account),acc_accountdetail_code) as  acc_accountdetail_code, "
                  + "IIF(ACC_ACCOUNTTYPE='Liabilities',(select acc_accountdetail_name from innovator.ACC_ACCOUNTDETAILS where id=POP_PURCHASE_INVOICE.acc_account),acc_accountdetail_name) as  acc_accountdetail_name,"
                  + "acc_sg_credit,acc_sg_debit, ACC_POP_VOUCHER_REFERENCE, "
                  + " IIF(ACC_ACCOUNTTYPE='Liabilities',(acc_sg_debit-acc_sg_credit)/(1+(pop_gst_percent/100)),IIF(ACC_ACCOUNTTYPE='Income',acc_sg_credit-acc_sg_debit,acc_sg_debit-acc_sg_credit)) as acc_amount "
                  + " from innovator.ACC_JOURNAL_DETAILS "
                 + " inner join innovator.ACC_JOURNAL_HEADER on  ACC_JOURNAL_DETAILS.SOURCE_ID=ACC_JOURNAL_HEADER.id  "
                 + " inner join innovator.ACC_ACCOUNTDETAILS on ACC_JOURNAL_DETAILS.ACC_ACCOUNTID=ACC_ACCOUNTDETAILS.id "
                 + " inner join innovator.ACC_CHARTOFACCOUNT on ACC_CHARTOFACCOUNT.id=ACC_ACCOUNTDETAILS.SOURCE_ID  "
                  + "inner join innovator.POP_PURCHASE_INVOICE on ACC_JOURNAL_HEADER.ACC_POP_VOUCHER_REFERENCE=POP_PURCHASE_INVOICE.id"
                 + " inner join innovator.ACC_ACCOUNTPAYABLE on ACC_JOURNAL_HEADER.ACC_REFNO=ACC_ACCOUNTPAYABLE.ACC_REFERENCENO "
                 + " where ACC_ACCOUNTCONSOLE<>'Cash at Bank' and  ACC_ACCOUNTCONSOLE<>'Cash & cash equivalent'"
                 + date_condition

                  + " )  as Temp_Profit_and_Loss group by acc_accountdetail_code,acc_accountdetail_name,acc_accountconsole,ACC_ACCOUNTTYPE ";
                }

                Item _get_data = myInnovator.applySQL(query);

                var _get_data_count = _get_data.getItemCount();
                if (_get_data_count > 0)
                {
                    for (int i = 0; i < _get_data_count; i++)
                    {
                        var _get_data_result = _get_data.getItemByIndex(i);
                        var acc_accountconsole = _get_data_result.getProperty("acc_accountconsole");
                        var acc_accounttype = _get_data_result.getProperty("acc_accounttype");
                        var acc_accountdetail_name = _get_data_result.getProperty("acc_accountdetail_name");
                        var acc_accountdetail_code = _get_data_result.getProperty("acc_accountdetail_code");
                        var acc_amount = _get_data_result.getProperty("acc_amount");
                        var acc_thismonth_amount = _get_data_result.getProperty("acc_thismonth_amount");
                        Item _add_acc_ProfitandLoss_report = myInnovator.newItem("acc_ProfitandLoss_report", "add");
                        _add_acc_ProfitandLoss_report.setProperty("acc_account_console", acc_accountconsole);
                        _add_acc_ProfitandLoss_report.setProperty("acc_account_type", acc_accounttype);
                        _add_acc_ProfitandLoss_report.setProperty("acc_account_detail_code", acc_accountdetail_code);
                        _add_acc_ProfitandLoss_report.setProperty("acc_account_detail_name", acc_accountdetail_name);
                        _add_acc_ProfitandLoss_report.setProperty("acc_amount", acc_amount);
                        _add_acc_ProfitandLoss_report.setProperty("acc_from_date", acc_from_date);
                        _add_acc_ProfitandLoss_report.setProperty("acc_to_date", acc_to_date);
                        _add_acc_ProfitandLoss_report.setProperty("acc_accounting_method", acc_accounting_method);
                        _add_acc_ProfitandLoss_report.setProperty("acc_thismonth_amount", acc_thismonth_amount);
                        _add_acc_ProfitandLoss_report.setProperty("acc_currency_symbol", symbol);
                        _add_acc_ProfitandLoss_report.apply();
                    }
                }

                myInnovator.applySQL("UPDATE innovator.acc_ProfitandLoss_report set acc_order=1 where acc_account_console='Revenue'");
                myInnovator.applySQL("UPDATE innovator.acc_ProfitandLoss_report set acc_order=2 where acc_account_type='COGS'");
                myInnovator.applySQL("UPDATE innovator.acc_ProfitandLoss_report set acc_order=3 where acc_account_console<>'Revenue' and acc_account_type <> 'COGS' and acc_account_type<> 'Expenses' ");

                myInnovator.applySQL("UPDATE innovator.acc_ProfitandLoss_report set acc_order=4 where acc_account_type='Expenses'");
                //change COGS Account Console name
                myInnovator.applySQL("UPDATE innovator.acc_ProfitandLoss_report set acc_account_console='LESS:COST OF SALES' where acc_account_type='COGS'");
                //get total expenses
                myInnovator.applySQL("update innovator.ACC_PROFITANDLOSS_REPORT set "
                + " acc_total_expenses=(select sum(case when  ACC_ACCOUNT_TYPE ='Expenses' then acc_amount else 0 end) "
                + " from innovator.ACC_PROFITANDLOSS_REPORT), "
                + " acc_total_expenses_current=(select sum(case when  ACC_ACCOUNT_TYPE ='Expenses' then acc_thismonth_amount else 0 end)"
                + "from innovator.ACC_PROFITANDLOSS_REPORT)");
                //total group
                myInnovator.applySQL(" update innovator.ACC_PROFITANDLOSS_REPORT set "
                + "  ACC_OPERATING_PROFIT=(select sum(case when  ACC_ACCOUNT_CONSOLE ='Revenue' "
                + " then acc_amount else 0 end) - sum(case when  ACC_ACCOUNT_TYPE ='COGS' "
                + " then acc_amount else 0 end) from innovator.ACC_PROFITANDLOSS_REPORT ), "
                + " ACC_OPERATING_PROFIT_CURRENT=(select sum(case when  ACC_ACCOUNT_CONSOLE ='Revenue' "
                + " then acc_thismonth_amount else 0 end) - sum(case when  ACC_ACCOUNT_TYPE ='COGS' "
                + " then acc_thismonth_amount else 0 end) from innovator.ACC_PROFITANDLOSS_REPORT )");

                myInnovator.applySQL(" update innovator.ACC_PROFITANDLOSS_REPORT set "
                + " ACC_TOTAL_PROFIT= (select (sum(case when  ACC_ACCOUNT_CONSOLE ='Revenue' "
                + " then acc_amount else 0 end) - sum(case when  ACC_ACCOUNT_TYPE ='COGS' "
                + " then acc_amount else 0 end))+ sum(case when  ACC_ACCOUNT_CONSOLE ='Other Operating Income' "
                + " then acc_amount else 0 end) from innovator.ACC_PROFITANDLOSS_REPORT), "
                + " ACC_TOTAL_PROFIT_CURRENT=(select (sum(case when  ACC_ACCOUNT_CONSOLE ='Revenue' "
                + " then acc_thismonth_amount else 0 end) - sum(case when  ACC_ACCOUNT_TYPE ='COGS' "
                + " then acc_thismonth_amount else 0 end))+ sum(case when  ACC_ACCOUNT_CONSOLE ='Other Operating Income' "
                + " then acc_thismonth_amount else 0 end) from innovator.ACC_PROFITANDLOSS_REPORT)");

                myInnovator.applySQL(" update innovator.ACC_PROFITANDLOSS_REPORT set "
                + " ACC_RETAINED_PROFIT= (select ((sum(case when  ACC_ACCOUNT_CONSOLE ='Revenue' "
                + " then acc_amount else 0 end) - sum(case when  ACC_ACCOUNT_TYPE ='COGS'"
                + " then acc_amount else 0 end))+ sum(case when  ACC_ACCOUNT_CONSOLE ='Other Operating Income' "
                + " then acc_amount else 0 end))-sum(case when  ACC_ACCOUNT_TYPE ='Expenses' "
                + " then acc_amount else 0 end) from innovator.ACC_PROFITANDLOSS_REPORT), "
                + " ACC_RETAINED_PROFIT_CURRENT=(select ((sum(case when  ACC_ACCOUNT_CONSOLE ='Revenue' "
                + " then acc_thismonth_amount else 0 end) - sum(case when  ACC_ACCOUNT_TYPE ='COGS' "
                + " then acc_thismonth_amount else 0 end))+ sum(case when  ACC_ACCOUNT_CONSOLE ='Other Operating Income' "
                + " then acc_thismonth_amount else 0 end))-sum(case when  ACC_ACCOUNT_TYPE ='Expenses' "
                + " then acc_thismonth_amount else 0 end) from innovator.ACC_PROFITANDLOSS_REPORT)");
                //for balance sheet
                myInnovator.applySQL("update innovator.ACC_ACCOUNTDETAILS  set ACC_AMOUNT= " +
                " (select top 1(ACC_RETAINED_PROFIT)  from innovator.ACC_PROFITANDLOSS_REPORT) where ACC_ACCOUNTDETAIL_NAME='Current year (profit) / loss'");

                /*Add For Company Information  By THS*/
                Item getCompany = myInnovator.applyMethod("acc_getCompanyInfo", "");
                string companyID = getCompany.getID();
                myInnovator.applySQL("UPDATE innovator.acc_ProfitandLoss_report set acc_company ='" + companyID + "'");
                /*End*/
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_ProfitandLoss_Cash_sp</name>
 </Item>
</AML>